Index: LMDZ5/branches/testing/libf/phylmd/calbeta_clim.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/calbeta_clim.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/calbeta_clim.F90	(revision 1750)
@@ -0,0 +1,67 @@
+!
+! $Header: /home/cvsroot/LMDZ4/libf/phylmd/calbeta.F90,v 1.2 2007/06/22 12:49:51
+! fairhead Exp $
+!
+
+SUBROUTINE calbeta_clim(klon,time,lat_radian,beta)
+ 
+!======================================================================
+! Auteur(s): A.K. TRAORE
+!======================================================================
+!USE phys_local_var_mod, ONLY : ideal_beta !pour faire la variable dans le
+! physiq.f pour des sorties directes de beta
+!==============================================
+
+implicit none
+integer klon,nt,j,it
+real logbeta(klon),pi
+real lat(klon),lat_radian(klon)
+integer time
+real time_radian
+real lat_sahel,beta(klon)
+real lat_nord,lat_sud
+!==============================================
+
+pi=2.*asin(1.)
+beta=0.
+    
+            !calcul des cordonnees
+
+!  print*,'LATITUDES BETA ',lat_radian
+   time_radian=(time+15.)*2.*pi/360.
+
+   print*,'BETA time_radian',time_radian,time
+
+   lat(:)=180.*lat_radian(:)/pi !lat(:)=lat_radian(:)
+        
+   lat_sahel=-5*sin(time_radian)+13
+   lat_nord=lat_sahel+25.
+   lat_sud=lat_sahel-25.
+do j=1,klon
+    !===========
+        if (lat(j) < 5. ) then
+                
+                logbeta(j)=0.2*(lat(j)-lat_sud)-1.6
+                beta(j)=10**(logbeta(j))
+                beta(j)=max(beta(j),0.03)
+                beta(j)=min(beta(j),0.22)
+!              print*,'j,lat,lat_radian,beta',j,lat(j),lat_radian(j),beta(j)
+    !===========
+        elseif (lat(j) < 22.) then !lat(j)<22.
+                
+                logbeta(j)=-0.25*(lat(j)-lat_sahel)-1.6
+                beta(j)=10**(logbeta(j))
+                beta(j)=max(beta(j),1.e-2)
+                beta(j)=min(beta(j),0.22)
+!              print*,'j,lat,lat_radian,beta',j,lat(j),lat_radian(j),beta(j)
+    !===========
+        else
+              logbeta(j)=0.25*(lat(j)-lat_nord)-1.
+              beta(j)=10**(logbeta(j))
+              beta(j)=max(beta(j),1.e-2)
+              beta(j)=min(beta(j),0.25)
+!              print*,'j,lat,lat_radian,beta',j,lat(j),lat_radian(j),beta(j)
+        endif
+    !===========
+enddo
+end
Index: LMDZ5/branches/testing/libf/phylmd/calltherm.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/calltherm.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/calltherm.F90	(revision 1750)
@@ -234,5 +234,5 @@
      &      ,tau_thermals,Ale,Alp,lalim_conv,wght_th &
      &      ,zmax0,f0,zw2,fraca)
-          else if (iflag_thermals==15.or.iflag_thermals==16) then
+          else if (iflag_thermals>=15.and.iflag_thermals<=18) then
 
 !            print*,'THERM iflag_thermas_ed=',iflag_thermals_ed
@@ -271,5 +271,5 @@
 ! fait bien ce qu'on croit.
 
-       flag_bidouille_stratocu=iflag_thermals<=12.or.iflag_thermals==14.or.iflag_thermals==16
+       flag_bidouille_stratocu=iflag_thermals<=12.or.iflag_thermals==14.or.iflag_thermals==16.or.iflag_thermals==18
 
       if (iflag_thermals<=12) then
Index: LMDZ5/branches/testing/libf/phylmd/clesphys.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/clesphys.h	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/clesphys.h	(revision 1750)
@@ -19,4 +19,5 @@
 !IM ajout CFMIP2/CMIP5
        REAL co2_ppm_per
+       LOGICAL ok_4xCO2atm
        REAL(kind=8) RCO2_per,RCH4_per,RN2O_per,RCFC11_per,RCFC12_per
        REAL(kind=8) CH4_ppb_per,N2O_ppb_per,CFC11_ppt_per,CFC12_ppt_per
@@ -81,4 +82,5 @@
      &     , RCO2, RCH4, RN2O, RCFC11, RCFC12                           &
      &     , RCO2_act, RCH4_act, RN2O_act, RCFC11_act, RCFC12_act       &
+     &     , ok_4xCO2atm                                                & 
      &     , RCO2_per, RCH4_per, RN2O_per, RCFC11_per, RCFC12_per       &
      &     , CH4_ppb, N2O_ppb, CFC11_ppt, CFC12_ppt                     &
Index: LMDZ5/branches/testing/libf/phylmd/cltrac.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cltrac.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/cltrac.F90	(revision 1750)
@@ -2,5 +2,7 @@
 ! $Id $
 !
-SUBROUTINE cltrac(dtime,coef,t,tr,flux,paprs,pplay,delp,d_tr)
+SUBROUTINE cltrac(dtime,coef,t,tr,flux,paprs,pplay,delp, &
+                  d_tr,d_tr_dry,flux_tr_dry)                    !jyg
+
   USE dimphy
   IMPLICIT NONE
@@ -13,16 +15,18 @@
 ! Arguments:
 !-----------
-! dtime....input-R- intervalle du temps (en secondes)
-! coef.....input-R- le coefficient d'echange (m**2/s) l>1
-! t........input-R- temperature (K)
-! tr.......input-R- la q. de traceurs
-! flux.....input-R- le flux de traceurs a la surface
-! paprs....input-R- pression a inter-couche (Pa)
-! pplay....input-R- pression au milieu de couche (Pa)
-! delp.....input-R- epaisseur de couche (Pa)
-! cdrag....input-R- cdrag pour le flux de surface (non active)
-! tr0......input-R- traceurs a la surface ou dans l'ocean (non active)
-! d_tr.....output-R- le changement de tr
-! flux_tr..output-R- flux de tr
+! dtime.......input-R- intervalle du temps (en secondes)
+! coef........input-R- le coefficient d'echange (m**2/s) l>1
+! t...........input-R- temperature (K)
+! tr..........input-R- la q. de traceurs
+! flux........input-R- le flux de traceurs a la surface
+! paprs.......input-R- pression a inter-couche (Pa)
+! pplay.......input-R- pression au milieu de couche (Pa)
+! delp........input-R- epaisseur de couche (Pa)
+! cdrag.......input-R- cdrag pour le flux de surface (non active)
+! tr0.........input-R- traceurs a la surface ou dans l'ocean (non active)
+! d_tr........output-R- le changement de tr
+! d_tr_dry....output-R- le changement de tr du au depot sec (1st layer)
+! flux_tr_dry.output-R- depot sec
+!!! flux_tr..output-R- flux de tr
 !======================================================================
   include "YOMCST.h"
@@ -40,4 +44,6 @@
 !
   REAL ,DIMENSION(klon,klev),INTENT(OUT) :: d_tr
+  REAL ,DIMENSION(klon),INTENT(OUT)       :: d_tr_dry          !jyg
+  REAL ,DIMENSION(klon),INTENT(OUT)       :: flux_tr_dry       !jyg
 !  REAL ,DIMENSION(klon,klev),INTENT(OUT) :: flux_tr
 !
@@ -66,5 +72,7 @@
      zx_alf1(i) = (paprs(i,1)-pplay(i,2))/(pplay(i,1)-pplay(i,2))
      zx_alf2(i) = 1.0 - zx_alf1(i)
-     zx_flux(i) =  -flux(i)*dtime*RG
+     flux_tr_dry(i) = -flux(i)*dtime                              !jyg
+     zx_flux(i) =  flux_tr_dry(i)*RG                              !jyg
+!!     zx_flux(i) =  -flux(i)*dtime*RG                            !jyg
 ! Pour le moment le flux est prescrit cdrag et zx_coef(1) vaut 0
      cdrag(i) = 0.0 
@@ -95,4 +103,5 @@
      zx_dtr(i,2) = (zx_coef(i,2)-zx_alf2(i)*zx_coef(i,1)) /   & 
           zx_buf(i)
+     d_tr_dry(i) = -zx_flux(i)/zx_buf(i)                          !jyg
   ENDDO
 
Index: LMDZ5/branches/testing/libf/phylmd/coef_diff_turb_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/coef_diff_turb_mod.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/coef_diff_turb_mod.F90	(revision 1750)
@@ -158,5 +158,5 @@
          
 !   iflag_pbl peut etre utilise comme longuer de melange
-       IF (iflag_pbl.GE.11) THEN
+       IF (iflag_pbl.GE.18) THEN
           CALL vdif_kcay(knon,dtime,RG,RD,ypaprs,yt, &
                yzlev,yzlay,yu,yv,yteta, &
Index: LMDZ5/branches/testing/libf/phylmd/concvl.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/concvl.F	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/concvl.F	(revision 1750)
@@ -10,5 +10,11 @@
      .             pbase,bbase,dtvpdt1,dtvpdq1,dplcldt,dplcldr,
      .             qcondc,wd,pmflxr,pmflxs,
-     .             da,phi,mp,dd_t,dd_q,lalim_conv,wght_th)
+! RomP >>>
+!!     .             da,phi,mp,dd_t,dd_q,lalim_conv,wght_th)
+     .             da,phi,mp,phi2,d1a,dam,sij,clw,elij,        ! RomP
+     .             dd_t,dd_q,lalim_conv,wght_th,               ! RomP
+     .             evap, ep, epmlmMm,eplaMm,                   ! RomP
+     .             wdtrainA,wdtrainM)                          ! RomP
+! RomP <<<
 ***************************************************************
 *                                                             *
@@ -91,4 +97,12 @@
 
        real da(klon,klev),phi(klon,klev,klev),mp(klon,klev)
+! RomP >>>
+       real phi2(klon,klev,klev)                                    
+       real d1a(klon,klev),dam(klon,klev)
+       real sij(klon,klev,klev),clw(klon,klev),elij(klon,klev,klev)
+       REAL wdtrainA(klon,klev),wdtrainM(klon,klev)
+       REAL evap(klon,klev),ep(klon,klev)
+       REAL epmlmMm(klon,klev,klev),eplaMm(klon,klev)
+! RomP <<<
        REAL cape(klon),cin(klon),tvp(klon,klev)
        REAL Tconv(klon,klev)
@@ -248,5 +262,5 @@
          DO i = 1, klon
           cbmf(i) = 0.
-          plcl(i) = 0.
+!!          plcl(i) = 0.
           sigd(i) = 0.
          ENDDO
@@ -256,4 +270,5 @@
       plfc(:)  = 0.
       wbeff(:) = 100.
+      plcl(:) = 0.
 
       DO k = 1, klev+1
@@ -339,13 +354,16 @@
       if (iflag_con.eq.30) then
 
-      CALL cv_driver(klon,klev,klev+1,ntra,iflag_con,
+      print *, '-> cv_driver'      !jyg
+      CALL cv_driver(klon,klev,klevp1,ntra,iflag_con,
      :              t,q,qs,u,v,tra,
      $              em_p,em_ph,iflag,
      $              d_t,d_q,d_u,d_v,d_tra,rain,
-!!     $              pmflxr,cbmf,work1,work2,           !jyg
-     $              Vprecip,cbmf,work1,work2,            !jyg
+     $              Vprecip,cbmf,work1,work2,                  !jyg
      $              kbas,ktop,
      $              dtime,Ma,upwd,dnwd,dnwdbis,qcondc,wd,cape,
-     $              da,phi,mp)
+     $              da,phi,mp,phi2,d1a,dam,sij,clw,elij,       !RomP
+     $              evap,ep,epmlmMm,eplaMm,                    !RomP
+     $              wdtrainA,wdtrainM)                         !RomP
+      print *, 'cv_driver ->'      !jyg
 c
       DO i = 1,klon
@@ -369,7 +387,8 @@
      $              dd_t,dd_q,Plim1,Plim2,asupmax,supmax0,
      $              asupmaxmin,lalim_conv,
-!AC!
-     $              da,phi)
-!AC!
+!AC!+!RomP
+     $              da,phi,mp,phi2,d1a,dam,sij,clw,  ! RomP
+     $              elij,evap,ep,wdtrainA,wdtrainM)  ! RomP
+!AC!+!RomP
       endif  
 C------------------------------------------------------------------
Index: LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 1750)
@@ -1,3 +1,2 @@
-
 !
 ! $Id: conf_phys.F90 1668 2012-10-12 10:47:37Z idelkadi $
@@ -18,5 +17,5 @@
                        iflag_cldcon, &
                        iflag_ratqs,ratqsbas,ratqshaut,tau_ratqs, &
-  		       ok_ade, ok_aie, aerosol_couple, &
+  		       ok_ade, ok_aie, ok_cdnc, aerosol_couple, &
                        flag_aerosol, new_aod, &
                        bl95_b0, bl95_b1,&
@@ -60,4 +59,5 @@
 ! ok_instan:  sorties instantanees
 ! ok_ade, ok_aie: apply or not aerosol direct and indirect effects
+! ok_cdnc, ok cloud droplet number concentration
 ! bl95_b*: parameters in the formula to link CDNC to aerosol mass conc 
 !
@@ -70,5 +70,5 @@
   logical              :: ok_LES
   LOGICAL              :: callstats
-  LOGICAL              :: ok_ade, ok_aie, aerosol_couple
+  LOGICAL              :: ok_ade, ok_aie, ok_cdnc, aerosol_couple
   INTEGER              :: flag_aerosol
   LOGICAL              :: new_aod
@@ -79,10 +79,11 @@
 
   character (len = 6),SAVE  :: type_ocean_omp, version_ocean_omp, ocean_omp
+  character (len = 10),SAVE  :: type_veget_omp
   CHARACTER(len = 8),SAVE   :: aer_type_omp
-  logical,SAVE              :: ok_veget_omp, ok_newmicro_omp
+  logical,SAVE              :: ok_newmicro_omp
   logical,SAVE        :: ok_journe_omp, ok_mensuel_omp, ok_instan_omp, ok_hf_omp        
   logical,SAVE        :: ok_LES_omp   
   LOGICAL,SAVE        :: callstats_omp
-  LOGICAL,SAVE        :: ok_ade_omp, ok_aie_omp, aerosol_couple_omp
+  LOGICAL,SAVE        :: ok_ade_omp, ok_aie_omp, ok_cdnc_omp, aerosol_couple_omp
   INTEGER, SAVE       :: flag_aerosol_omp
   LOGICAL, SAVE       :: new_aod_omp
@@ -129,4 +130,5 @@
   REAL,SAVE :: CFC11_ppt_omp,RCFC11_omp,CFC11_ppt_per_omp,RCFC11_per_omp
   REAL,SAVE :: CFC12_ppt_omp,RCFC12_omp,CFC12_ppt_per_omp,RCFC12_per_omp
+  LOGICAL,SAVE :: ok_4xCO2atm_omp
   REAL,SAVE :: epmax_omp
   LOGICAL,SAVE :: ok_adj_ema_omp
@@ -216,6 +218,6 @@
 !Config Help = Type de modele de vegetation utilise
 !
-  ok_veget_omp = .false.
-  call getin('VEGET', ok_veget_omp)
+  type_veget_omp ='orchidee'
+  call getin('VEGET', type_veget_omp)
 !
 !Config Key  = OK_journe
@@ -273,4 +275,12 @@
 
 !
+!Config Key  = ok_cdnc
+!Config Desc = ok cloud droplet number concentration
+!Config Def  = .false.
+!Config Help = Used in newmicro.F
+!
+  ok_cdnc_omp = .false.
+  call getin('ok_cdnc', ok_cdnc_omp)
+!
 !Config Key  = aerosol_couple
 !Config Desc = read aerosol in file or calcul by inca
@@ -280,5 +290,4 @@
   aerosol_couple_omp = .false.
   CALL getin('aerosol_couple',aerosol_couple_omp)
-
 !
 !Config Key  = flag_aerosol
@@ -523,4 +532,12 @@
 !               
   RCO2_per_omp = co2_ppm_per_omp * 1.0e-06  * 44.011/28.97
+
+!Config Key  = ok_4xCO2atm
+!Config Desc = Calcul ou non effet radiatif 4xco2
+!Config Def  = .false.
+!Config Help = 
+
+  ok_4xCO2atm_omp = .false.
+  call getin('ok_4xCO2atm',ok_4xCO2atm_omp)
 
 !Config Key  = RCH4_per
@@ -1605,4 +1622,5 @@
     RCFC11_act = RCFC11
     RCFC12_act = RCFC12
+    ok_4xCO2atm = ok_4xCO2atm_omp
     RCO2_per = RCO2_per_omp
     RCH4_per = RCH4_per_omp
@@ -1666,5 +1684,12 @@
     type_ocean = type_ocean_omp
     version_ocean = version_ocean_omp
-    ok_veget = ok_veget_omp
+
+    ok_veget=.true.
+    type_veget=type_veget_omp
+    if (type_veget=='n' .or. type_veget=='bucket' .or. type_veget=='betaclim' ) &
+         & then
+         ok_veget=.false.
+    endif
+
     ok_newmicro = ok_newmicro_omp
     ok_journe = ok_journe_omp
@@ -1677,4 +1702,5 @@
     ok_ade = ok_ade_omp
     ok_aie = ok_aie_omp
+    ok_cdnc = ok_cdnc_omp
     aerosol_couple = aerosol_couple_omp
     flag_aerosol=flag_aerosol_omp
@@ -1775,4 +1801,9 @@
     END IF
 
+! ok_cdnc must be set to y if ok_aie is activated
+    IF (ok_aie .AND. .NOT. ok_cdnc) THEN
+       CALL abort_gcm('conf_phys', 'ok_cdnc must be set to y if ok_aie is activated',1)
+    ENDIF 
+
 !$OMP MASTER
 
@@ -1781,5 +1812,5 @@
   write(lunout,*)' Type ocean = ', type_ocean
   write(lunout,*)' Version ocean = ', version_ocean
-  write(lunout,*)' Config veget = ', ok_veget
+  write(lunout,*)' Config veget = ', ok_veget,type_veget
   write(lunout,*)' Sortie journaliere = ', ok_journe
   write(lunout,*)' Sortie haute frequence = ', ok_hf
@@ -1800,4 +1831,5 @@
   write(lunout,*)' CFC11_ppt=',CFC11_ppt,' RCFC11_act=  ',RCFC11_act
   write(lunout,*)' CFC12_ppt=',CFC12_ppt,' RCFC12_act=  ',RCFC12_act
+  write(lunout,*)' ok_4xCO2atm=',ok_4xCO2atm
   write(lunout,*)' RCO2_per = ',RCO2_per,' RCH4_per = ', RCH4_per
   write(lunout,*)' RN2O_per = ',RN2O_per,' RCFC11_per = ', RCFC11_per
Index: LMDZ5/branches/testing/libf/phylmd/cv30_routines.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv30_routines.F	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/cv30_routines.F	(revision 1750)
@@ -1831,5 +1831,6 @@
      :              ,th,tv,lv,cpn,ep,sigp,clw
      :              ,m,ment,elij,delt,plcl
-     :              ,mp,rp,up,vp,trap,wt,water,evap,b)
+     :              ,mp,rp,up,vp,trap,wt,water,evap,b ! RomP-jyg
+     :              ,wdtrainA,wdtrainM)               ! 26/08/10  RomP-jyg
       implicit none
 
@@ -1857,4 +1858,9 @@
       real trap(nloc,na,ntra)
       real b(nloc,na)
+! 25/08/10 - RomP---- ajout des masses precipitantes ejectees
+! lascendance adiabatique et des flux melanges Pa et Pm.
+! Distinction des wdtrain
+! Pa = wdtrainA     Pm = wdtrainM
+      real  wdtrainA(nloc,na), wdtrainM(nloc,na)
 
 c local variables
@@ -1898,5 +1904,12 @@
 c         enddo
 c        enddo
-
+!! RomP >>>
+         do i=1,nd
+          do il=1,ncum
+          wdtrainA(il,i)=0.0     
+          wdtrainM(il,i)=0.0     
+         enddo
+        enddo
+!! RomP <<<
 c
 c   ***  check whether ep(inb)=0, if so, skip precipitating    ***
@@ -1935,6 +1948,8 @@
          if (cvflag_grav) then
           wdtrain(il)=grav*ep(il,i)*m(il,i)*clw(il,i)
+          wdtrainA(il,i) = wdtrain(il)/grav     !   Pa  26/08/10   RomP
          else
           wdtrain(il)=10.0*ep(il,i)*m(il,i)*clw(il,i)
+          wdtrainA(il,i) = wdtrain(il)/10.      !   Pa  26/08/10   RomP
          endif
         endif
@@ -1942,4 +1957,5 @@
 
        if(i.gt.1)then
+
         do 320 j=1,i-1
          do il=1,ncum
@@ -1955,4 +1971,12 @@
          enddo
 320     continue
+         do il=1,ncum
+           if (cvflag_grav) then
+           wdtrainM(il,i) = wdtrain(il)/grav-wdtrainA(il,i)    !   Pm  26/08/10   RomP
+           else
+           wdtrainM(il,i) = wdtrain(il)/10.-wdtrainA(il,i)    !   Pm  26/08/10   RomP
+           endif
+         enddo
+
        endif
 
@@ -3022,44 +3046,139 @@
         end
 
+!!RomP >>>
       SUBROUTINE cv30_tracer(nloc,len,ncum,nd,na,
-     &                        ment,sij,da,phi)
+     &                       ment,sij,da,phi,phi2,d1a,dam,
+     &                       ep,VPrecip,elij,clw,epmlmMm,eplaMm,
+     &                       icb,inb)
         implicit none
+
+#include "cv30param.h"
+
 c inputs:
         integer ncum, nd, na, nloc,len
         real ment(nloc,na,na),sij(nloc,na,na)
+	real clw(nloc,nd),elij(nloc,na,na)
+	real ep(nloc,na)
+        integer icb(nloc),inb(nloc)
+        real VPrecip(nloc,nd+1)
 c ouputs:
         real da(nloc,na),phi(nloc,na,na)
+	real phi2(nloc,na,na)
+	real d1a(nloc,na),dam(nloc,na)
+	real epmlmMm(nloc,na,na),eplaMm(nloc,na)
+! variables pour tracer dans precip de l'AA et des mel
 c local variables:
         integer i,j,k
-c        
-        da(:,:)=0.
-c
+	real epm(nloc,na,na)
+c
+! variables d'Emanuel : du second indice au troisieme
+! --->    tab(i,k,j) -> de l origine k a l arrivee j 
+!  ment, sij, elij
+! variables personnelles : du troisieme au second indice
+! --->    tab(i,j,k) -> de k a j 
+! phi, phi2
+!
+! initialisations
+       do j=1,na
+        do i=1,ncum
+         da(i,j)=0.
+         d1a(i,j)=0.
+         dam(i,j)=0.
+         eplaMm(i,j)=0.
+        enddo
+       enddo
+      do k=1,na
+       do j=1,na
+        do i=1,ncum
+         epm(i,j,k)=0.
+         epmlmMm(i,j,k)=0.
+         phi(i,j,k)=0.
+         phi2(i,j,k)=0.
+        enddo
+       enddo
+      enddo
+c
+!  fraction deau condensee dans les melanges convertie en precip : epm
+! et eau condensée précipitée dans masse d'air saturé : l_m*dM_m/dzdz.dzdz
+        do j=1,na
+         do k=1,j-1
+           do i=1,ncum
+            if(k.ge.icb(i).and.k.le.inb(i).and.
+     &         j.le.inb(i)) then
+!!jyg             epm(i,j,k)=1.-(1.-ep(i,j))*clw(i,j)/elij(i,k,j)
+             epm(i,j,k)=1.-(1.-ep(i,j))*clw(i,j)/
+     &                     max(elij(i,k,j),1.e-16)
+!!
+             epm(i,j,k)=max(epm(i,j,k),0.0)
+            endif
+           end do 
+         end do 
+        end do
+!
+        do j=1,na
+         do k=1,na
+           do i=1,ncum
+            if(k.ge.icb(i).and.k.le.inb(i)) then
+             eplaMm(i,j)=eplaMm(i,j) + ep(i,j)*clw(i,j)
+     &                  *ment(i,j,k)*(1.-sij(i,j,k))
+            endif
+           end do 
+         end do 
+        end do
+!
+        do j=1,na
+         do k=1,j-1
+           do i=1,ncum
+            if(k.ge.icb(i).and.k.le.inb(i).and.
+     &         j.le.inb(i)) then
+             epmlmMm(i,j,k)=epm(i,j,k)*elij(i,k,j)*ment(i,k,j)
+            endif
+           end do 
+         end do 
+        end do
+
+!  matrices pour calculer la tendance des concentrations dans cvltr.F90
         do j=1,na
           do k=1,na
             do i=1,ncum
-            da(i,j)=da(i,j)+(1.-sij(i,k,j))*ment(i,k,j)
-            phi(i,j,k)=sij(i,k,j)*ment(i,k,j)
-c            print *,'da',j,k,da(i,j),sij(i,k,j),ment(i,k,j)
+             da(i,j)=da(i,j)+(1.-sij(i,k,j))*ment(i,k,j)
+             phi(i,j,k)=sij(i,k,j)*ment(i,k,j)
+             d1a(i,j)=d1a(i,j)+ment(i,k,j)*ep(i,k)
+     &              *(1.-sij(i,k,j))
             end do 
           end do 
         end do 
-    
+
+        do j=1,na
+          do k=1,j-1
+            do i=1,ncum
+             dam(i,j)=dam(i,j)+ment(i,k,j)
+     &             *epm(i,j,k)*(1.-ep(i,k))*(1.-sij(i,k,j)) 
+             phi2(i,j,k)=phi(i,j,k)*epm(i,j,k)
+            end do 
+          end do 
+        end do 
+
         return
         end
-
+!RomP <<<
 
       SUBROUTINE cv30_uncompress(nloc,len,ncum,nd,ntra,idcum
      :         ,iflag
-     :         ,precip,VPrecip,sig,w0
+     :         ,precip,VPrecip,evap,ep,sig,w0
      :         ,ft,fq,fu,fv,ftra
      :         ,inb
      :         ,Ma,upwd,dnwd,dnwd0,qcondc,wd,cape
-     :         ,da,phi,mp
+     :         ,da,phi,mp,phi2,d1a,dam,sij
+     :         ,elij,clw,epmlmMm,eplaMm
+     :         ,wdtrainA,wdtrainM
      :         ,iflag1
-     :         ,precip1,VPrecip1,sig1,w01
+     :         ,precip1,VPrecip1,evap1,ep1,sig1,w01
      :         ,ft1,fq1,fu1,fv1,ftra1
      :         ,inb1
      :         ,Ma1,upwd1,dnwd1,dnwd01,qcondc1,wd1,cape1
-     :         ,da1,phi1,mp1)
+     :         ,da1,phi1,mp1,phi21,d1a1,dam1,sij1
+     :         ,elij1,clw1,epmlmMm1,eplaMm1
+     :         ,wdtrainA1,wdtrainM1)
       implicit none
 
@@ -3072,5 +3191,6 @@
       integer inb(nloc)
       real precip(nloc)
-      real VPrecip(nloc,nd+1)
+      real VPrecip(nloc,nd+1),evap(nloc,nd)
+      real ep(nloc,nd)
       real sig(nloc,nd), w0(nloc,nd)
       real ft(nloc,nd), fq(nloc,nd), fu(nloc,nd), fv(nloc,nd)
@@ -3081,4 +3201,12 @@
       real wd(nloc),cape(nloc)
       real da(nloc,nd),phi(nloc,nd,nd),mp(nloc,nd)
+!RomP >>>
+      real phi2(nloc,nd,nd)
+      real d1a(nloc,nd),dam(nloc,nd)
+      real wdtrainA(nloc,nd), wdtrainM(nloc,nd)
+      real sij(nloc,nd,nd)
+      real elij(nloc,nd,nd),clw(nloc,nd)
+      real epmlmMm(nloc,nd,nd),eplaMm(nloc,nd)
+!RomP <<<
 
 c outputs:
@@ -3086,5 +3214,6 @@
       integer inb1(len)
       real precip1(len)
-      real VPrecip1(len,nd+1)
+      real VPrecip1(len,nd+1),evap1(len,nd) !<<< RomP
+      real ep1(len,nd)                      !<<< RomP
       real sig1(len,nd), w01(len,nd)
       real ft1(len,nd), fq1(len,nd), fu1(len,nd), fv1(len,nd)
@@ -3095,4 +3224,12 @@
       real wd1(nloc),cape1(nloc)
       real da1(nloc,nd),phi1(nloc,nd,nd),mp1(nloc,nd)
+!RomP >>>
+      real phi21(len,nd,nd)
+      real d1a1(len,nd),dam1(len,nd)
+      real wdtrainA1(len,nd), wdtrainM1(len,nd)
+      real sij1(len,nd,nd)
+      real elij1(len,nd,nd),clw1(len,nd)
+      real epmlmMm1(len,nd,nd),eplaMm1(len,nd)
+!RomP <<<
 
 c local variables:
@@ -3110,4 +3247,5 @@
           do 2010 i=1,ncum
             VPrecip1(idcum(i),k)=VPrecip(i,k)
+            evap1(idcum(i),k)=evap(i,k)   !<<< RomP
             sig1(idcum(i),k)=sig(i,k)
             w01(idcum(i),k)=w0(i,k)
@@ -3123,4 +3261,13 @@
             da1(idcum(i),k)=da(i,k)
             mp1(idcum(i),k)=mp(i,k)
+!RomP >>>
+            ep1(idcum(i),k)=ep(i,k)
+            d1a1(idcum(i),k)=d1a(i,k)
+            dam1(idcum(i),k)=dam(i,k)
+            clw1(idcum(i),k)=clw(i,k)
+            eplaMm1(idcum(i),k)=eplaMm(i,k)
+            wdtrainA1(idcum(i),k)=wdtrainA(i,k)
+            wdtrainM1(idcum(i),k)=wdtrainM(i,k)
+!RomP <<<
  2010     continue
  2020   continue
@@ -3141,5 +3288,9 @@
          do k=1,nd 
           do i=1,ncum
+            sij1(idcum(i),k,j)=sij(i,k,j)
             phi1(idcum(i),k,j)=phi(i,k,j)
+            phi21(idcum(i),k,j)=phi2(i,k,j)
+            elij1(idcum(i),k,j)=elij(i,k,j)
+            epmlmMm1(idcum(i),k,j)=epmlmMm(i,k,j)
           end do
          end do
Index: LMDZ5/branches/testing/libf/phylmd/cv3_routines.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv3_routines.F	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/cv3_routines.F	(revision 1750)
@@ -1950,5 +1950,6 @@
      :              ,th,tv,lv,cpn,ep,sigp,clw
      :              ,m,ment,elij,delt,plcl,coef_clos
-     o              ,mp,rp,up,vp,trap,wt,water,evap,b,sigd)
+     o              ,mp,rp,up,vp,trap,wt,water,evap,b,sigd
+     o              ,wdtrainA,wdtrainM)                                ! RomP
       implicit none
 
@@ -1979,4 +1980,9 @@
       real trap(nloc,na,ntra)
       real b(nloc,na), sigd(nloc)
+! 25/08/10 - RomP---- ajout des masses precipitantes ejectees
+! lascendance adiabatique et des flux melanges Pa et Pm.
+! Distinction des wdtrain
+! Pa = wdtrainA     Pm = wdtrainM
+      real  wdtrainA(nloc,na), wdtrainM(nloc,na)
 
 c local variables
@@ -2021,4 +2027,12 @@
 !AC!         enddo
 !AC!        enddo
+!! RomP >>>
+         do i=1,nd
+          do il=1,ncum
+          wdtrainA(il,i)=0.0     
+          wdtrainM(il,i)=0.0     
+         enddo
+        enddo
+!! RomP <<<
 c
 c   ***  check whether ep(inb)=0, if so, skip precipitating    ***
@@ -2065,6 +2079,8 @@
          if (cvflag_grav) then
           wdtrain(il)=grav*ep(il,i)*m(il,i)*clw(il,i)
+          wdtrainA(il,i) = wdtrain(il)/grav     !   Pa   RomP
          else
           wdtrain(il)=10.0*ep(il,i)*m(il,i)*clw(il,i)
+          wdtrainA(il,i) = wdtrain(il)/10.      !   Pa   RomP
          endif
         endif
@@ -2079,6 +2095,8 @@
            if (cvflag_grav) then
             wdtrain(il)=wdtrain(il)+grav*awat*ment(il,j,i)
+            wdtrainM(il,i) = wdtrain(il)/grav-wdtrainA(il,i)    !   Pm  RomP
            else
             wdtrain(il)=wdtrain(il)+10.0*awat*ment(il,j,i)
+            wdtrainM(il,i) = wdtrain(il)/10.-wdtrainA(il,i)    !   Pm  RomP
            endif
           endif
@@ -3540,29 +3558,79 @@
         end
 
-!AC!
+!AC! et !RomP >>>
       SUBROUTINE cv3_tracer(nloc,len,ncum,nd,na,
-     &                        ment,sij,da,phi)
+     &                       ment,sigij,da,phi,phi2,d1a,dam,
+     &                       ep,Vprecip,elij,clw,icb,inb)
         implicit none
+
+#include "cv3param.h"
+
 c inputs:
         integer ncum, nd, na, nloc,len
-        real ment(nloc,na,na),sij(nloc,na,na)
+        real ment(nloc,na,na),sigij(nloc,na,na)
+	real clw(nloc,nd),elij(nloc,na,na)
+	real ep(nloc,na)
+        integer icb(nloc),inb(nloc)
+        real VPrecip(nloc,nd+1)
 c ouputs:
         real da(nloc,na),phi(nloc,na,na)
+	real phi2(nloc,na,na)
+	real d1a(nloc,na),dam(nloc,na)
+! variables pour tracer dans precip de l'AA et des mel
 c local variables:
         integer i,j,k
-c        
-        da(:,:)=0.
-c
+	real epm(nloc,na,na)
+c
+! variables d'Emanuel : du second indice au troisieme
+! --->    tab(i,k,j) -> de l origine k a l arrivee j 
+!  ment, sigij, elij
+! variables personnelles : du troisieme au second indice
+! --->    tab(i,j,k) -> de k a j 
+! phi, phi2
+!
+! initialisations
+c
+       da(:,:)=0.
+       d1a(:,:)=0.
+       dam(:,:)=0.
+       epm(:,:,:)=0.
+c
+!  fraction deau condensee dans les melanges convertie en precip
+        do j=1,na
+         do k=1,na
+           do i=1,ncum
+            if(k.ge.icb(i).and.k.le.inb(i).and.
+     &         j.ge.k.and.j.le.inb(i)) then
+             epm(i,j,k)=1.-(1.-ep(i,j))*clw(i,j)/elij(i,k,j)
+             epm(i,j,k)=max(epm(i,j,k),0.0)
+            endif
+           end do 
+         end do 
+        end do 
+
+!  matrices pour calculer la tendance des concentrations dans cvltr.F90
         do j=1,na
           do k=1,na
             do i=1,ncum
-            da(i,j)=da(i,j)+(1.-sij(i,k,j))*ment(i,k,j)
-            phi(i,j,k)=sij(i,k,j)*ment(i,k,j)
+             da(i,j)=da(i,j)+(1.-sigij(i,k,j))*ment(i,k,j)
+             phi(i,j,k)=sigij(i,k,j)*ment(i,k,j)
+             d1a(i,j)=d1a(i,j)+ment(i,k,j)*ep(i,k)
+     &              *(1.-sigij(i,k,j))
+            if(k.le.j) then
+             dam(i,j)=dam(i,j)+ment(i,k,j)
+     &             *epm(i,k,j)*(1.-ep(i,k))*(1.-sigij(i,k,j)) 
+
+             phi2(i,j,k)=phi(i,j,k)*epm(i,j,k)   
+            else
+             dam(i,j)=0.
+             phi2(i,j,k)=0.
+            endif
             end do 
           end do 
         end do 
+   
         return
         end
-!AC!
+!AC! et !RomP <<<
 
       SUBROUTINE cv3_uncompress(nloc,len,ncum,nd,ntra,idcum
